/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the vertex of the generated diagram
// abstract class of the generated diagram

#ifndef __DIAGRAM_H__
#define __DIAGRAM_H__

#include "orderdata.h"

typedef short Coord_e_t;

class Vertex_e {
 public:
  ElementId element;
  ElementId dummy;
  Coord_e_t x;
  Coord_e_t y;
  // comparison function for STL
  bool
    operator <(const Vertex_e &v) const
    {
      if (element < v.element) return true;
      if (v.element < element) return false;
      return ((element == NoElement) && (v.element == NoElement) && 
	      (dummy < v.dummy));
    }
};

class Diagram {
 public:
  struct generationParams_t {};
  
  Diagram() {}
  virtual ~Diagram() {}
  virtual void generateDiagram(generationParams_t *params) = 0;
  // generates the diagram
  virtual void getDiagram(set<Vertex_e> &s) = 0;
  // returns: the diagram, verteces in s
};

#endif
