/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the diagram window

#ifndef __DIAGRAMWINDOW_H__
#define __DIAGRAMWINDOW_H__

#include "orderedsets.h"
#include <gtk--/window.h>

class DiagramArea;
class AppWindow;
class DiagramPopupMenu;

class DiagramWindow : public Gtk::Window {
 protected:
  OrderedSets *orderedsets;
  OrderedSet *orderedset;
  string title;
  DiagramPopupMenu *popupmenu;
  DiagramArea *area;
  // on window close
  bool reallyClose();
  // on window manager close
  gint delete_event_impl(GdkEventAny* e);
 public:
  DiagramWindow(AppWindow *appwin, OrderedSets *oss, OrderedSet *os,
		int min_width = 200, int min_height = 200);
  ~DiagramWindow();
  void update();
  void setTitle();
  void close();
};

#endif
