/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the ordered set collection (factory)

#ifndef __ORDEREDSETS_H__
#define __ORDEREDSETS_H__

#include "orderedset.h"

class LIBLATVIS_API OrderedSets {
 protected:
  struct RefOrderedSet_t {
    OrderedSet *orderedset;
    int *refcounter;
    // comparison functor for STL
    bool
    operator <(const RefOrderedSet_t &s) const
    {
      return (*orderedset < *(s.orderedset));
    }
  };
  set<RefOrderedSet_t> sets;
 public:
  ~OrderedSets();
  OrderedSet *newSet(OrderedSet::data_t data_type);
  // creates new set with data representation data_type
  // returns: the set, or NULL
  bool refSet(OrderedSet *s);
  // increases reference counter of the set s
  // returns: of successful (not)
  bool unrefSet(OrderedSet *s);
  // decreases reference counter of the set s, when it reaches zero,
  // deletes the set
  // returns: if successful (not)
  bool areAllSetsSaved();
  // returns: if all sets are saved
};

#endif
